Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Classification_Script.cs	(revision 11677)
@@ -0,0 +1,106 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Linq.Expressions;
+
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.Instances.DataAnalysis;
+using HeuristicLab.Scripting;
+
+using LibSVM;
+
+public class SVMClassificationCrossValidationScript : HeuristicLab.Scripting.CSharpScriptBase {
+  /* Maximum degree of parallelism (specifies whether or not the grid search should be parallelized) */
+  const int maximumDegreeOfParallelism = 4;
+
+  /* Number of crossvalidation folds: */
+  const int numberOfFolds = 5;
+
+  /* Specify whether the folds should be shuffled */
+  const bool shuffleFolds = false;
+
+  /* The tunable SVM parameters:
+     - "C" (penalty factor) effects the trade-off between complexity and proportion of nonseparable samples and must be selected by the user. Can have any positive value.
+     - "nu" is an upper bound on the fraction of margin errors and a lower bound of the fraction of support vectors relative to the total number of training examples.
+     - "degree" represents the polynomial kernel degree
+     - "eps" (epsilon) determines the level of accuracy of the approximated function. It controls the width of the epsilon-insensitive zone used to fit the training data.
+       With optimal values of epsilon, the parameter C has negligible effect.
+     - "degree" represents the degree of the polynomial kernel
+     - "kernel_type" specifies the kernel to be used: linear, polynomial, radial basis or sigmoidal.
+       Valid values: svm_parameter.LINEAR, svm_parameter.POLY, svm_parameter.RBF, svm_parameter.SIGMOID
+     Comment or uncomment the parameter ranges below as needed.  */
+
+  static Dictionary<string, IEnumerable<double>> svmParameterRanges = new Dictionary<string, IEnumerable<double>> {
+        { "svm_type", new List<double> {svm_parameter.NU_SVC } },
+        { "kernel_type", new List<double> { svm_parameter.RBF }},
+        { "C", ValueGenerator.GenerateSteps(-1m, 10, 1).Select(x => Math.Pow(2,(double)x)) },
+        { "gamma", ValueGenerator.GenerateSteps(-4m, -1, 1).Select(x => Math.Pow(2,(double)x)) },
+//        { "eps", ValueGenerator.GenerateSteps(-8m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
+        { "nu" , ValueGenerator.GenerateSteps(-10m, 0, 1m).Select(x => Math.Pow(2, (double)x)) },
+//        { "degree", ValueGenerator.GenerateSteps(1m, 4, 1).Select(x => (double)x) }
+  };
+
+  static Dictionary<int, string> svmTypes = new Dictionary<int, string> {
+    { svm_parameter.NU_SVC, "NU_SVC" },
+    { svm_parameter.C_SVC, "C_SVC" }
+  };
+
+  static Dictionary<int, string> kernelTypes = new Dictionary<int, string> {
+    { svm_parameter.LINEAR, "LINEAR" },
+    { svm_parameter.POLY, "POLY" },
+    { svm_parameter.RBF, "RBF" },
+    { svm_parameter.SIGMOID, "SIGMOID" }
+  };
+
+  private static SupportVectorClassificationSolution SvmGridSearch(IClassificationProblemData problemData, out svm_parameter bestParameters, out int nSv, out double cvMse) {
+    bestParameters = SupportVectorMachineUtil.GridSearch(out cvMse, problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
+    double trainingError, testError;
+    string svmType = svmTypes[bestParameters.svm_type];
+    string kernelType = kernelTypes[bestParameters.kernel_type];
+    var svm_solution = SupportVectorClassification.CreateSupportVectorClassificationSolution(problemData, problemData.AllowedInputVariables, svmType, kernelType,
+                       bestParameters.C, bestParameters.nu, bestParameters.gamma, bestParameters.degree, out trainingError, out testError, out nSv);
+    return svm_solution;
+  }
+
+  public override void Main() {
+    var variables = (Variables)vars;
+    var item = variables.SingleOrDefault(x => x.Value is IClassificationProblem || x.Value is IClassificationProblemData);
+    if (item.Equals(default(KeyValuePair<string, object>)))
+      throw new ArgumentException("Could not find a suitable problem or problem data.");
+
+    string name = item.Key;
+    IClassificationProblemData problemData;
+    if (item.Value is IClassificationProblem)
+      problemData = ((IClassificationProblem)item.Value).ProblemData;
+    else
+      problemData = (IClassificationProblemData)item.Value;
+
+    int nSv; // number of support vectors
+    double cvMse;
+    svm_parameter bestParameters;
+    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv, out cvMse);
+
+    vars["bestSolution"] = bestSolution;
+    Console.WriteLine(name + " parameters: C = {0}, g = {1:0.000}, eps = {2:0.000}, nu = {3:0.000}, degree = {4}", bestParameters.C, bestParameters.gamma, bestParameters.eps, bestParameters.nu, bestParameters.degree);
+    Console.WriteLine(name + " best solution accuracy (training): " + bestSolution.TrainingAccuracy + ", accuracy (test): " + bestSolution.TestAccuracy);
+
+    var bestParametersCollection = new ParameterCollection();
+    foreach (var p in svmParameterRanges.Keys) {
+      var getter = GenerateGetter(p);
+      bestParametersCollection.Add(new FixedValueParameter<DoubleValue>(p, new DoubleValue(getter(bestParameters))));
+    }
+    vars["bestParameters"] = bestParametersCollection;
+  }
+
+  private static Func<svm_parameter, double> GenerateGetter(string field) {
+    var paramExpr = Expression.Parameter(typeof(svm_parameter));
+    var getterExpr = Expression.Convert(Expression.Field(paramExpr, field), typeof(double)); // cast to double
+    Func<svm_parameter, double> f = Expression.Lambda<Func<svm_parameter, double>>(getterExpr, paramExpr).Compile();
+    return f;
+  }
+}
+
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/GridSearch_SVM_Regression_Script.cs	(revision 11677)
@@ -0,0 +1,107 @@
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Linq.Expressions;
+
+using HeuristicLab.Algorithms.DataAnalysis;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.Problems.Instances.DataAnalysis;
+using HeuristicLab.Scripting;
+
+using LibSVM;
+
+public class SVMRegressionCrossValidationScript : HeuristicLab.Scripting.CSharpScriptBase {
+  /* Maximum degree of parallelism (specifies whether or not the grid search should be parallelized) */
+  const int maximumDegreeOfParallelism = 4;
+
+  /* Number of crossvalidation folds: */
+  const int numberOfFolds = 5;
+
+  /* Specify whether the folds should be shuffled */
+  const bool shuffleFolds = false;
+
+  /* The tunable SVM parameters:
+     - "C" (penalty factor) effects the trade-off between complexity and proportion of nonseparable samples and must be selected by the user. Can have any positive value.
+     - "nu" is an upper bound on the fraction of margin errors and a lower bound of the fraction of support vectors relative to the total number of training examples.
+     - "degree" represents the polynomial kernel degree
+     - "eps" (epsilon) determines the level of accuracy of the approximated function. It controls the width of the epsilon-insensitive zone used to fit the training data.
+       With optimal values of epsilon, the parameter C has negligible effect.
+     - "degree" represents the degree of the polynomial kernel
+     - "kernel_type" specifies the kernel to be used: linear, polynomial, radial basis or sigmoidal.
+       Valid values: svm_parameter.LINEAR, svm_parameter.POLY, svm_parameter.RBF, svm_parameter.SIGMOID
+     Comment or uncomment the parameter ranges below as needed.  */
+
+  static Dictionary<string, IEnumerable<double>> svmParameterRanges = new Dictionary<string, IEnumerable<double>> {
+        { "svm_type", new List<double> {svm_parameter.NU_SVR } },
+        { "kernel_type", new List<double> { svm_parameter.RBF }},
+        { "C", ValueGenerator.GenerateSteps(-1m, 12, 1).Select(x => Math.Pow(2, (double)x)) },
+        { "gamma", ValueGenerator.GenerateSteps(-4m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
+//        { "eps", ValueGenerator.GenerateSteps(-8m, -1, 1).Select(x => Math.Pow(2, (double)x)) },
+        { "nu" , ValueGenerator.GenerateSteps(-10m, 0, 1m).Select(x => Math.Pow(2, (double)x)) },
+//        { "degree", ValueGenerator.GenerateSteps(1m, 4, 1).Select(x => (double)x) }
+  };
+
+  static Dictionary<int, string> svmTypes = new Dictionary<int, string> {
+    { svm_parameter.NU_SVR, "NU_SVR" },
+    { svm_parameter.EPSILON_SVR, "EPSILON_SVR" }
+  };
+
+  static Dictionary<int, string> kernelTypes = new Dictionary<int, string> {
+    { svm_parameter.LINEAR, "LINEAR" },
+    { svm_parameter.POLY, "POLY" },
+    { svm_parameter.RBF, "RBF" },
+    { svm_parameter.SIGMOID, "SIGMOID" }
+  };
+
+  private static SupportVectorRegressionSolution SvmGridSearch(IRegressionProblemData problemData, out svm_parameter bestParameters, out int nSv, out double cvMse) {
+    bestParameters = SupportVectorMachineUtil.GridSearch(out cvMse, problemData, svmParameterRanges, numberOfFolds, shuffleFolds, maximumDegreeOfParallelism);
+    double trainingError, testError;
+    string svmType = svmTypes[bestParameters.svm_type];
+    string kernelType = kernelTypes[bestParameters.kernel_type];
+    var svm_solution = SupportVectorRegression.CreateSupportVectorRegressionSolution(problemData, problemData.AllowedInputVariables, svmType, kernelType,
+                       bestParameters.C, bestParameters.nu, bestParameters.gamma, bestParameters.eps, bestParameters.degree, out trainingError, out testError, out nSv);
+    return svm_solution;
+  }
+
+  public override void Main() {
+    var variables = (Variables)vars;
+    var item = variables.SingleOrDefault(x => x.Value is IRegressionProblem || x.Value is IRegressionProblemData);
+    if (item.Equals(default(KeyValuePair<string, object>)))
+      throw new ArgumentException("Could not find a suitable problem or problem data.");
+
+    string name = item.Key;
+    IRegressionProblemData problemData;
+    if (item.Value is IRegressionProblem)
+      problemData = ((IRegressionProblem)item.Value).ProblemData;
+    else
+      problemData = (IRegressionProblemData)item.Value;
+
+    int nSv; // number of support vectors
+    double cvMse;
+    svm_parameter bestParameters;
+    var bestSolution = SvmGridSearch(problemData, out bestParameters, out nSv, out cvMse);
+
+    vars["bestSolution"] = bestSolution;
+    Console.WriteLine(name + " parameters: C = {0}, g = {1:0.000}, eps = {2:0.000}, nu = {3:0.000}, degree = {4}", bestParameters.C, bestParameters.gamma, bestParameters.eps, bestParameters.nu, bestParameters.degree);
+    Console.WriteLine(name + " best solution mse (training): " + bestSolution.TrainingMeanSquaredError + ", mse (test): " + bestSolution.TestMeanSquaredError);
+    Console.WriteLine(name + " best solution R2 (training): " + bestSolution.TrainingRSquared + ", R2 (test): " + bestSolution.TestRSquared);
+
+    var bestParametersCollection = new ParameterCollection();
+    foreach (var p in svmParameterRanges.Keys) {
+      var getter = GenerateGetter(p);
+      bestParametersCollection.Add(new FixedValueParameter<DoubleValue>(p, new DoubleValue(getter(bestParameters))));
+    }
+    vars["bestParameters"] = bestParametersCollection;
+  }
+
+  private static Func<svm_parameter, double> GenerateGetter(string field) {
+    var paramExpr = Expression.Parameter(typeof(svm_parameter));
+    var getterExpr = Expression.Convert(Expression.Field(paramExpr, field), typeof(double)); // cast to double
+    Func<svm_parameter, double> f = Expression.Lambda<Func<svm_parameter, double>>(getterExpr, paramExpr).Compile();
+    return f;
+  }
+}
+
Index: branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/OSGA_Rastrigin_Script.cs
===================================================================
--- branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/OSGA_Rastrigin_Script.cs	(revision 11677)
+++ branches/ALPS/HeuristicLab.Tests/Test Resources/Script Sources/OSGA_Rastrigin_Script.cs	(revision 11677)
@@ -0,0 +1,111 @@
+﻿using System;
+using System.Linq;
+
+public class OSGARastriginScript : HeuristicLab.Scripting.CSharpScriptBase {
+  public override void Main() {
+    int N = vars.N.Value;
+    double minX = vars.minX.Value;
+    double maxX = vars.maxX.Value;
+    int seed = vars.seed.Value;
+    var rand = new Random(seed);
+
+    var result = OSGA(rand, popSize: 1000, iterations: 5000, maxSelPres: 1000, mutationRate: 0.1,
+         obj: Rastrigin,
+      // x ~(i.i.d) U(0,1) * 10.24 - 5.12
+         creator: () => Enumerable.Range(1, N).Select(_ => rand.NextDouble() * (maxX - minX) + minX).ToArray(),
+      // random parent selection
+         selector: (f) => rand.Next(f.Length),
+      // single point crossover
+         crossover: (p0, p1, cand) => {
+           int cut = rand.Next(cand.Length);
+           Array.Copy(p0, cand, cut);
+           Array.Copy(p1, cut, cand, cut, cand.Length - cut);
+         },
+      // single point manipulation
+         manipulator: (p) => p[rand.Next(N)] = rand.NextDouble() * (maxX - minX) + minX,
+         output: true
+      );
+
+    double bestFit = result.Item2;
+    vars.bestFitness = bestFit;
+    Console.WriteLine("best fitness: {0}", bestFit);
+  }
+
+  private double Rastrigin(double[] x) {
+    return 10.0 * x.Length + x.Sum(xi => xi * xi - 10.0 * Math.Cos(2.0 * Math.PI * xi));
+  }
+
+  private Tuple<T, double> OSGA<T>(Random rand, int popSize, int iterations, double maxSelPres, double mutationRate, Func<T, double> obj,
+      Func<T> creator, Func<double[], int> selector, Action<T, T, T> crossover, Action<T> manipulator,
+      bool output = false)
+      where T : ICloneable {
+    // generate random pop
+    T[] pop = Enumerable.Range(0, popSize).Select(_ => creator()).ToArray();
+    // evaluate initial pop
+    double[] fit = pop.Select(p => obj(p)).ToArray();
+
+    // arrays for next pop (clone current pop because solutions are reused)
+    T[] popNew = pop.Select(pi => (T)pi.Clone()).ToArray();
+    double[] fitNew = new double[popSize];
+
+    var bestSolution = (T)pop.First().Clone(); // take a random solution (don't care)
+    double bestFit = fit.First();
+
+    // run generations
+    double curSelPres = 0;
+    for (int g = 0; g < iterations && curSelPres < maxSelPres; g++) {
+      // keep the first element as elite
+      int i = 1;
+      int genEvals = 0;
+      do {
+        var p1Idx = selector(fit);
+        var p2Idx = selector(fit);
+
+        var p1 = pop[p1Idx];
+        var p2 = pop[p2Idx];
+        var f1 = fit[p1Idx];
+        var f2 = fit[p2Idx];
+
+        // generate candidate solution (reuse old solutions)
+        crossover(p1, p2, popNew[i]);
+        // optional mutation
+        if (rand.NextDouble() < mutationRate) {
+          manipulator(popNew[i]);
+        }
+
+        double f = obj(popNew[i]);
+        genEvals++;
+        // if child is better than best (strict offspring selection)
+        if (f < Math.Min(f1, f2)) {
+          // update best fitness
+          if (f < bestFit) {
+            bestFit = f;
+            bestSolution = (T)popNew[i].Clone(); // overall best
+          }
+
+          // keep
+          fitNew[i] = f;
+          i++;
+        }
+
+        curSelPres = genEvals / (double)popSize;
+      } while (i < popNew.Length && curSelPres < maxSelPres);
+
+      Console.WriteLine("generation {0} obj {1:0.000} sel. pres. {2:###.0}", g, bestFit, curSelPres);
+
+      // swap 
+      var tmpPop = pop;
+      var tmpFit = fit;
+      pop = popNew;
+      fit = fitNew;
+      popNew = tmpPop;
+      fitNew = tmpFit;
+
+      // keep elite
+      popNew[0] = (T)bestSolution.Clone();
+      fitNew[0] = bestFit;
+    }
+
+    return Tuple.Create(bestSolution, bestFit);
+  }
+}
